include \masm32\MasmBasic\MasmBasic.inc
.686
.xmm
include \masm32\macros\timers.asm	; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]

ShakeSort	PROTO: DWORD, :DWORD
MbCombSort	PROTO: DWORD, :DWORD

FakeStruct	STRUCT
TheR4	REAL4 ?
FakeStruct	ENDS

LOOP_COUNT =	100	; One Mio would be a typical value
repCount = 7		; timing loops
WantError = 1		; test the CombSortA problem
tcDone=0
tcSize=0
TestCorrectness MACRO algo
LOCAL ctx
	ctx=8
	ifidn <algo>, <CombSortA>
		ctx=7	; CombSortA will throw a GPF is FPU is full
	endif
	pushad
	finit
	repeat ctx
	fldpi
	endm
	tcSize=ArrSize
	mov esi, offset R4Array
	if 0
		tcSize=sizeof FailArray
		mov esi, offset FailArray
	endif
	mov edi, offset Dest
	ife tcDone
		tcDone=1
		invoke MbCopy, edi, esi, tcSize
		invoke nrQsortA, edi, tcSize/4
		invoke MbCopy, offset RefArray, edi, tcSize
	endif
	mov ebx, tcSize/4
	invoke MbCopy, edi, esi, tcSize+4
;	void Str$(0)
;	sub ebx, 3
	invoke algo, edi, ebx
;	add ebx, 3
	mov esi, offset RefArray
	xor ecx, ecx
	dec ebx
	push ebx
	.Repeat
		mov eax, [esi+4*ebx]	; esi=RefArray
		.if eax!=[edi+4*ebx]		; edi=Dest
			inc ecx
		.endif
		dec ebx
	.Until Sign?
	Print Str$("%i errors for &algo&\n", ecx)
	pop ebx
	.Repeat
		;Print Str$(ebx), Str$("\t%f\n", [edi.FakeStruct.TheR4+4*ebx])
		dec ebx
	.Until Sign?
	popad
ENDM
.data
align 16
FailArray	REAL4 123.456, 99.0, -3000.0, 3000.0, 0.0, 3.0e-20, 3.0e20, 1.000001, 0.999999, 1.00001e2, 0.99999e2, 1.0
align 16
	if 0
R4Array	REAL4 123.456, 99.0, -3000.0, 3000.0, 0.0, 3.0e-20, 3.0e20, 1.000001, 0.999999, 1.00001e2, 0.99999e2, 1.0
	REPEAT 199
	REAL4 123.456, 99.0, -3000.0, 3000.0, 0.0, 3.0e-20, 3.0e20, 1.000001, 0.999999, 1.00001e2, 0.99999e2, 1.0
	ENDM
	else
R4Array	REAL4 123.456, 3.3e30, 99.0, -3000.0, 3000.0, 0.0, 3.0e-20, 3.0e20, 1.000001, 0.999999, 1.00001e2, 0.99999e2, 1.0, 33.44, 44.55, 55.66, 66.77, 77.88, 88.99, 98.76
	REPEAT 4999
	REAL4 123.456, 3.3e30, 99.0, -3000.0, 3000.0, 0.0, 3.0e-20, 3.0e20, 1.000001, 0.999999, 1.00001e2, 0.99999e2, 1.0, 33.44, 44.55, 55.66, 66.77, 77.88, 88.99, 98.76
	ENDM
	endif
	ArrSize=500*(sizeof R4Array)	; 11->220 items: 120000/1600000000*60i*20y=0.09 secs (P4: 220000->0.15 secs)
; 2000*:
; 777994687	cycles for ShakeSort
; 9227566		cycles for CombSortA
.data?
Dest	REAL4 ArrSize dup(?)
RefArray	REAL4 ArrSize dup(?)

.code
start:	push 1
	call ShowCpu	; print brand string and SSE level
	SleepMs =	50	; test if anything changes when changing this
;	mov ebx, esp
;	pushad
;	mov esi, esp
;	mov edi, esp
;	sub edi, ebx
;	deb 1, "Pushad", ebx, esi, edi
;	popad
	TestCorrectness nrQsortA
	TestCorrectness ShakeSort
	if WantError
		void Str$(0)
	else
		finit
	endif
	TestCorrectness CombSortA
	void Str$(0)
	TestCorrectness MbCombSort
	finit
	TestCorrectness MbCombSort
;	TestCorrectness ShakeSort
;	TestCorrectness MbCombSort
;	TestCorrectness ShakeSort
	mov esi, offset FailArray
	mov edi, offset Dest
	Print Str$("\nItems: %i\n", tcSize/4)
	.if eax==27
		Exit
	.endif
	invoke MbCopy, edi, esi, sizeof FailArray+4
	void Str$(0)
	; finit	; CombSort needs a virgin FPU
	mov ebx, sizeof FailArray/4
	invoke CombSortA, edi, ebx
	dec ebx
	PrintLine "Masm32:"
	.Repeat
;		.if ebx>ArrSize/4-11 || ebx<=4
			Print Str$(ebx), Str$("\t%f\n", [edi.FakeStruct.TheR4+4*ebx])
;		.endif
		dec ebx
	.Until Sign?
	invoke MbCopy, edi, esi, sizeof FailArray+4
	void Str$(0)
;	 finit	; MbCombSort does not need a virgin FPU, but it doesn't do any harm
	mov ebx, sizeof FailArray/4
	invoke MbCombSort, edi, ebx
	dec ebx
	PrintLine CrLf$, "JJ up:"
	.Repeat
		Print Str$(ebx), Str$("\t%f\n", [edi.FakeStruct.TheR4+4*ebx])
		dec ebx
	.Until Sign?

;	mov ebx, sizeof FailArray/-4	no good for JWasm
	mov ebx, -(sizeof FailArray/4)
;	neg ebx
	invoke MbCombSort, edi, ebx
	neg ebx
	dec ebx
	PrintLine CrLf$, "JJ down:"
	.Repeat
		Print Str$(ebx), Str$("\t%f\n", [edi.FakeStruct.TheR4+4*ebx])
		dec ebx
	.Until Sign?

	Inkey CrLf$, "More?", CrLf$
	.if eax==27
		Exit
	.endif
if 0
	mov ebx, sizeof FailArray/4
	invoke MbCopy, edi, esi, sizeof FailArray+4
	invoke nrQsortA, edi, ebx
	dec ebx
	PrintLine CrLf$, "Masm32 QuickSort:"
	.Repeat
;		.if ebx>ArrSize/4-11 || ebx<=4
			Print Str$(ebx), Str$("\t%f\n", [edi.FakeStruct.TheR4+4*ebx])
;		.endif
		dec ebx
	.Until Sign?
endif
;	Inkey "OK?", CrLf$
;	.if eax==27
;		Exit
;	.endif
		mov esi, offset R4Array			; use a long array
		PrintLine
	REPEAT repCount
	if 1
		invoke Sleep, SleepMs
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov ebx, ArrSize/4
				invoke MbCopy, edi, esi, ArrSize+4
				invoke nrQsortA, edi, ebx
		counter_end
		print str$(eax), 9, "cycles for nrQsortA", 13, 10
	endif
		invoke Sleep, SleepMs
			if WantError
				void Str$(0)
			else
				finit
			endif
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov ebx, ArrSize/4
				invoke MbCopy, edi, esi, ArrSize+4
				invoke CombSortA, edi, ebx
		counter_end
		print str$(eax), 9, "cycles for CombSortA", 13, 10
		invoke Sleep, SleepMs
		void Str$(0)
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov ebx, ArrSize/4
				invoke MbCopy, edi, esi, ArrSize+4
				invoke MbCombSort, edi, ebx
		counter_end
		print str$(eax), 9, "cycles for MbCombSort", 13, 10
		if 0
		finit
		counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
				mov ebx, ArrSize/4
				invoke MbCopy, edi, esi, ArrSize+4
				invoke MbCombSort, edi, ebx
		counter_end
		print str$(eax), 9, "cycles for MbCombSort finit", 13, 10
		endif
		print chr$(13, 10)
	ENDM
		Print Str$("\nItems:\t%i\n", tcSize/4)
	CodeSize nrQsortA
	CodeSize CombSortA
	CodeSize MbCombSort
	inkey chr$(13, 10, "--- ok ---", 13)
	exit

ShowCpu proc	; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h	; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h		; cpuid 1
  xor ebx, ebx		; CpuSSE
  xor esi, esi		; add zero plus the carry flag
  bt edx, 25		; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26		; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi		; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9			; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]	; dec mode in stack
  .if Zero?
	mov edi, esp	; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	.if byte ptr [edi]<32
		print chr$("pre-P4")
	.else
		print edi	; CpuBrand
	.endif
	.if ebx
		print chr$(32, 40, "SSE")	; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10	; 41=)
	.endif
  .endif
  add esp, 80		; discard brand buffer (after printing!)
  mov [esp+32-4], ebx	; move ebx into eax stack position - returns eax to main for further use
  ifdef MbBufferInit
	call MbBufferInit
  endif
  popad
  ret 4
ShowCpu endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShakeSort_s:
ShakeSort proc pArray, items	; [url=http://en.wikipedia.org/wiki/Cocktail_sort]Wiki[/url]
  push ebp
  push esi
  push edi
  push ebx
  xBegin equ <ebp>
  or xBegin, -1
  xEnd equ <edi>
  mov xEnd, [esp+16+8]	; items
  sub xEnd, 2
  mov esi, [esp+16+4]		;pArray
;  int 3
  align 4
  .Repeat
	xor ecx, ecx		; swapped
	inc xBegin
	mov edx, xBegin
;	deb 4, "Sh A", xBegin, xEnd
	align 4
	.Repeat
		mov eax, [esi+4*edx]
		inc edx
		mov ebx, [esi+4*edx]
		.if signed eax>ebx
			mov [esi+4*edx-4], ebx
			inc ecx		; flag swapped
			mov [esi+4*edx], eax
		.endif
	.Until signed edx>xEnd
;	deb 4, "Sh B", xBegin, xEnd, ecx
	if 0
		test ecx, ecx
		je ShSortEnd
	else
		jecxz ShSortEnd
	endif
	dec xEnd
	xor ecx, ecx		; swapped
	mov edx, xEnd
;	deb 4, "Sh C", xBegin, xEnd, edx
	align 4
	.Repeat
		mov eax, [esi+4*edx]
		mov ebx, [esi+4*edx+4]
		.if signed eax>ebx
			mov [esi+4*edx], ebx
			inc ecx		; flag swapped
			mov [esi+4*edx+4], eax
		.endif
		dec edx
	.Until Sign?
;	deb 4, "Sh D", xBegin, xEnd, ecx
  .Until !ecx
ShSortEnd:
  pop ebx
  pop edi
  pop esi
  pop ebp
  ret 8
ShakeSort endp
ShakeSort_endp:
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef
align 16
CombSortA_s:
      cons REAL4 1.3
CombSortA proc Arr:DWORD,aSize:DWORD

    LOCAL Gap   :DWORD
    LOCAL eFlag :DWORD
    push ebx
    push esi
    push edi

    mov eax, aSize
    mov Gap, eax
    mov esi, Arr    ; address of 1st element
    dec aSize

  stLbl:
    fild Gap        ; load integer memory operand to divide
    fdiv cons       ; divide number by 1.3
    fistp Gap       ; store result back in integer memory operand
    dec Gap
    jnz ovr
    mov Gap, 1		; gap=Max(1, gap-1)
  ovr:
    mov eFlag, 0

    mov edi, aSize
    sub edi, Gap
    xor ecx, ecx              ; low value index
  iLoop:
    mov edx, ecx
    add edx, Gap              ; high value index
    mov eax, [esi+ecx*4]      ; lower value
    mov ebx, [esi+edx*4]      ; higher value
    cmp eax, ebx
    jle iLnxt                 ; sort ascending
    mov [esi+edx*4], eax
    mov [esi+ecx*4], ebx
    inc eFlag
  iLnxt:

    inc ecx
    cmp ecx, edi
    jle iLoop

    cmp eFlag, 0
    jg stLbl
    cmp Gap, 1
    jg stLbl

    pop edi
    pop esi
    pop ebx

    ret

CombSortA endp
CombSortA_endp:

align 16
nrQsortA_s:
nrQsortA proc Arr:DWORD,count:DWORD

    LOCAL First :DWORD
    LOCAL Last  :DWORD
    LOCAL cntr  :DWORD
    LOCAL bLen  :DWORD
    LOCAL hMem  :DWORD
    LOCAL temp  :DWORD

    push ebx
    push esi
    push edi

    mov esi, Arr              ; source address in ESI

    mov cntr, 0

  ; --------------------------
  ; allocate temporary buffer
  ; --------------------------
    mov eax, count
    add eax, 40
    mov bLen, eax
    invoke SysAllocStringByteLen,0,bLen
    mov hMem, eax

    mov edi, hMem             ; buffer address in EDI

  ; ------------------------------------
  ; set First and Last reference values
  ; ------------------------------------
    mov First, 0
    mov eax, count
    dec eax
    mov Last, eax             ; Last = count - 1

  outer_loop:
  ; -------------------
  ; calculate midpoint
  ; -------------------
    mov eax, Last
    add eax, First
    shr eax, 1
  ; =========================
    mov ebx, [esi+eax*4]      ; midpoint in EBX
    mov temp, ebx
  ; =========================
    mov ecx, First
    mov edx, Last
  ; ---------------------------------------------------------
  inner_loop:
    cmp [esi+ecx*4], ebx
    jge wl2
    inc ecx
    jmp inner_loop
  wl2:
    cmp [esi+edx*4], ebx
    jle wl2Out
    dec edx
    jmp wl2
  wl2Out:
    cmp ecx, edx              ; If ecx > edx, exit inner loop
    jg exit_innerx
  ; =========================
    mov eax, [esi+ecx*4]
    mov ebx, [esi+edx*4]      ; swap elements
    mov [esi+ecx*4], ebx
    mov [esi+edx*4], eax
  ; =========================
    mov ebx, temp             ; restore EBX
    inc ecx
    dec edx
    cmp ecx, edx
    jle inner_loop
  exit_innerx:
  ; ---------------------------------------------------------
    cmp ecx, Last             ; If ecx < Last jump over
    jg iNxt
  ; =========================
    mov eax, cntr
    mov [edi+eax*4], ecx
    mov ebx, Last
    mov [edi+eax*4+4], ebx
  ; =========================
    add cntr, 2
  iNxt:
    mov ebx, temp             ; restore EBX
    mov Last, edx             ; Last  = EDX
    cmp edx, First            ; compare Last & First
    jg outer_loop

    cmp cntr, 0
    jz qsOut
    sub cntr, 2
  ; =========================
    mov eax, cntr
    mov ebx, [edi+eax*4]
    mov First, ebx
    mov ebx, [edi+eax*4+4]
    mov Last, ebx
  ; =========================
    mov ebx, temp             ; restore EBX
    jmp outer_loop

    qsOut:

    invoke SysFreeString,hMem

    pop edi
    pop esi
    pop ebx

    ret

nrQsortA endp
nrQsortA_endp:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 16	; Prescott P4: every digit has an influence!
; 10/200	0.70:54, 0.72:36, 0.722:37, 0.723:35, 0.724:36, 0.725:36, 0.726:35, 0.73:40, 0.75:41, 0.8:38
; 20/400	0.70:140, 0.701:85, 0.702:66, 0.703:66, 0.704:70, 0.705:73, 0.725:77, 0.72:77, 0.73:92, 0.74:166, 0.75:74
; 40/800	0.71:400, 0.72:197, 0.725:185, 0.73:154, 0.74:220, 0.75:160, 0.76:149, 0.77:142, 0.78:140, 0.79:150
; 250/5k	0.7:1760, 0.71:1450, 0.715:1700, 0.72:1250, 0.725:1040, 0.73:5000, 0.74:1000, 0.75:960, 0.76:1040, 0.77:1055
; 500/10k	0.7:28k, 0.71:2200, 0.715:5000, 0.717:1840, 0.718:2300, 0.719:2600, 0.72:1850, 0.721:3200, 0.73:2060, 0.75:2250, 0.8:2330, 
MbCombSort_s:
Cs13	REAL4 0.75	; ca. 1/1.333
MbCombSort proc xArr:DWORD, xaSize:DWORD
	pushad
	push eax		; one extra slot for fild
	aSize equ dword ptr [esp+9*4+8]		; 9: 8 for pushad, 1 for slot
	Arr equ [esp+9*4+4]
	Gap equ ebx
	sFlag equ dword ptr [esp]
	mov Gap, aSize
	mov esi, Arr		; address of 1st element
	ffree st(7)		; it is a good habit to leave the FPU intact
NewGap:	push Gap
	fild dword ptr [esp]		; put Gap into st(0)
	fmul Cs13		; divide Gap by 1.333
	fistp dword ptr [esp]		; back to stack
	pop Gap
	dec Gap
	jg @F
	m2m Gap, 1		; gap=Max(1, gap-1)
@@:	xor ecx, ecx		; low value index
	mov edi, aSize		; e.g. 10 or -10
	mov sFlag, ecx		; zero sFlag
	dec edi
	js csDown0		; sort descending if size is negative
	sub edi, Gap
	; align 4		; none/4/16: all 932 kcycles on P4, 5000 items
csUp:	lea edx, [esi+ecx*4]
	mov eax, [edx]		; lowval
	mov ebp, [edx+Gap*4]		; hival
	.if signed eax>ebp
		mov [edx+Gap*4], eax
		inc sFlag
		mov [edx], ebp
	.endif
	inc ecx
	cmp ecx, edi
	jle csUp
	jmp csNext
csDown0:
	lea edi, [edi+Gap+2]
	neg edi
csDown:	lea edx, [esi+ecx*4]
	mov eax, [edx]		; lowval
	mov ebp, [edx+Gap*4]		; hival
	.if signed eax<ebp
		mov [edx+Gap*4], eax
		inc sFlag
		mov [edx], ebp
	.endif
	inc ecx
	cmp ecx, edi
	jle csDown
csNext:	dec sFlag
		jge NewGap
	cmp Gap, 1
	jg NewGap
	pop eax		; delete extra slot
	popad
	ret 8
MbCombSort endp
MbCombSort_endp:
end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]

P4 timings:
Items:  10000
2821448 cycles for nrQsortA
3350106 cycles for CombSortA
2316684 cycles for MbCombSort

2158186 cycles for nrQsortA
2476503 cycles for CombSortA
2564312 cycles for MbCombSort

2127466 cycles for nrQsortA
2650659 cycles for CombSortA
3063289 cycles for MbCombSort

2390364 cycles for nrQsortA
2462296 cycles for CombSortA
2300143 cycles for MbCombSort

2127652 cycles for nrQsortA
2472897 cycles for CombSortA
2289645 cycles for MbCombSort

2190101 cycles for nrQsortA
4033114 cycles for CombSortA
2971516 cycles for MbCombSort

2123819 cycles for nrQsortA
2524952 cycles for CombSortA
2471882 cycles for MbCombSort

Items:  40000
8889560 cycles for nrQsortA
10174319        cycles for CombSortA
11379985        cycles for MbCombSort

8985936 cycles for nrQsortA
10441120        cycles for CombSortA
10906555        cycles for MbCombSort

8865737 cycles for nrQsortA
11086060        cycles for CombSortA
10123775        cycles for MbCombSort

9018093 cycles for nrQsortA
12722043        cycles for CombSortA
9896164 cycles for MbCombSort

9105226 cycles for nrQsortA
12113561        cycles for CombSortA
9837297 cycles for MbCombSort

9092452 cycles for nrQsortA
12783509        cycles for CombSortA
9859430 cycles for MbCombSort

9633516 cycles for nrQsortA
11336647        cycles for CombSortA
11898119        cycles for MbCombSort
